# Release notes for cobrapy 0.14.0

## New features

* Adding boundary reactions is now much more flexible and accepts 
  user-defined identifiers.
* It is now possible to run FVA and loopless FVA in parallel.
* Some utilities and an example of how to perform static optimization dynamic
  FBA. 
* There now is a global configuration singleton `cobra.Configuration()` that 
  can be used to set default bounds for newly created reactions and set a 
  default solver for all newly created or parsed models.
* Setting a time limit on solvers now still allows users to retrieve the flux
  distribution at the point of time out.

## Fixes

* Infinity values are now properly handled and passed down to optlang.
* Properly update the model objective on leaving a model context.
* New metabolites are now included in the gapfilling process.

## Deprecated features

* We are deprecating a special case of lower and upper bound behavior. Please
  read more about it in #793 and let us know what you think.

## Backwards incompatible changes

* The old solver interfaces that were deprecated for a long time have been 
  removed.

## Documentation

* Better documentation for the minimal medium functionality.
* Additions to the contribution guidelines.

## Internal

* Improve indexing for `find_blocked_reactions`.
* Adjust the test suite for pytest 4.0 and update the configuration.
* The module structure and corresponding tests are broken up and re-organized.

